      subroutine setbuf(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)


      if(blockty.eq.0) then
         call bufdat0(sendvec,recvec,nsize)

      elseif(blockty.eq.1) then
         call bufdat1(sendvec,recvec,nsize)

      elseif(blockty.eq.2) then
         call bufdat2(sendvec,recvec,nsize)

      elseif(blockty.eq.3) then
         call bufdat3(sendvec,recvec,nsize)

      elseif(blockty.eq.4) then
         call bufdat4(sendvec,recvec,nsize)

      elseif(blockty.eq.5) then
         call bufdat5(sendvec,recvec,nsize)

      elseif(blockty.eq.6) then
         call bufdat6(sendvec,recvec,nsize)

      elseif(blockty.eq.7) then
         call bufdat7(sendvec,recvec,nsize)

      else
         call bufdat8(sendvec,recvec,nsize)

      endif

      return
      end
**************************************************************************
**************************************************************************

      subroutine vectotop(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(ny+2)*nx

        do 1 k=0,ny+1
         n1=k*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1
         
         do 1 j=1,nx
                 u1s(j,k,nz+1)  =  recvec(n1+j)
                 u2s(j,k,nz+1)  =  recvec(n2+j)
                 u3s(j,k,nz+1)  =  recvec(n3+j)

                lag1s(j,k,nz+1)  =  recvec(n4+j)
                lag2s(j,k,nz+1)  =  recvec(n5+j)
                lag3s(j,k,nz+1)  =  recvec(n6+j)
    1  continue

       return
       end
**************************************************************************
**************************************************************************

      subroutine vectobot(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(ny+2)*nx

        do 1 k=0,ny+1
         n1=k*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1

         do 1 j=1,nx
                 u1n(j,k,0)  =  recvec(n1+j)
                 u2n(j,k,0)  =  recvec(n2+j)
                 u3n(j,k,0)  =  recvec(n3+j)

                lag1n(j,k,0)  =  recvec(n4+j)
                lag2n(j,k,0)  =  recvec(n5+j)
                lag3n(j,k,0)  =  recvec(n6+j)
    1  continue

       return
       end
***********************************************************************
***********************************************************************

      subroutine vectolef(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(nz+2)*nx

        do 1 l=0,nz+1
         n1=l*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1

         do 1 j=1,nx
                 u1e(j,0,l)  =  recvec(n1+j)
                 u2e(j,0,l)  =  recvec(n2+j)
                 u3e(j,0,l)  =  recvec(n3+j)

		 lag1e(j,0,l)  =  recvec(n4+j)
		 lag2e(j,0,l)  =  recvec(n5+j)
		 lag3e(j,0,l)  =  recvec(n6+j)
    1  continue

       return
       end
***********************************************************************
***********************************************************************

      subroutine vectorig(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(nz+2)*nx

        do 1 l=0,nz+1
         n1=l*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1
         do 1 j=1,nx
                 u1w(j,ny+1,l)  =  recvec(n1+j)
                 u2w(j,ny+1,l)  =  recvec(n2+j)
                 u3w(j,ny+1,l)  =  recvec(n3+j)

                lag1w(j,ny+1,l)  =  recvec(n4+j)
                lag2w(j,ny+1,l)  =  recvec(n5+j)
                lag3w(j,ny+1,l)  =  recvec(n6+j)
    1  continue

       return
       end
************************************************************************
************************************************************************

      subroutine tbrytovec(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(ny+2)*nx

        do 1 k=0,ny+1
         n1=k*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1
         do 1 j=1,nx
                sendvec(n1+j)  =  u1n(j,k,nz)
               sendvec(n2+j)  =  u2n(j,k,nz)
               sendvec(n3+j)  =  u3n(j,k,nz)
                sendvec(n4+j)  = lag1n(j,k,nz)
	        sendvec(n5+j)  = lag2n(j,k,nz)
		 sendvec(n6+j)  = lag3n(j,k,nz)
    1  continue

       return
       end
************************************************************************
************************************************************************

      subroutine bbrytovec(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(ny+2)*nx

        do 1 k=0,ny+1
         n1=k*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1
         do 1 j=1,nx
                sendvec(n1+j)  =  u1s(j,k,1)
                sendvec(n2+j)  =  u2s(j,k,1)
                sendvec(n3+j)  =  u3s(j,k,1)

		sendvec(n4+j)  = lag1s(j,k,1)
		sendvec(n5+j)  = lag2s(j,k,1)
		sendvec(n6+j)  = lag3s(j,k,1)
    1  continue

       return
       end
**********************************************************************
**********************************************************************

      subroutine lbrytovec(sendvec,recvec,nsize)
      include 'commons.aniso'
      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6

        n0=(nz+2)*nx

        do 1 l=0,nz+1
         n1=l*nx
         n2=n0+n1
         n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1
         do 1 j=1,nx
                sendvec(n1+j)  =  u1w(j,1,l)
               sendvec(n2+j)  =  u2w(j,1,l)
               sendvec(n3+j)  =  u3w(j,1,l)

                sendvec(n4+j)  = lag1w(j,1,l)
                sendvec(n5+j)  = lag2w(j,1,l)
                sendvec(n6+j)  = lag3w(j,1,l)
    1  continue
       return
       end
********************************************************************
********************************************************************

      subroutine rbrytovec(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)
      integer n0,n1,n2,n3,n4,n5,n6
         
        n0=(nz+2)*nx

        do 1 l=0,nz+1
         n1=l*nx
         n2=n0+n1
        n3=2*n0+n1
         n4=3*n0+n1
         n5=4*n0+n1
         n6=5*n0+n1

         do 1 j=1,nx
                sendvec(n1+j) =  u1e(j,ny,l)
                sendvec(n2+j) =  u2e(j,ny,l)
                sendvec(n3+j) =  u3e(j,ny,l)

                sendvec(n4+j) = lag1e(j,ny,l)
		sendvec(n5+j) = lag2e(j,ny,l)
		sendvec(n6+j) = lag3e(j,ny,l)
    1  continue
          
       return
       end
*******************************************************************
*******************************************************************

      subroutine bufdat0(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)
      


c       right shift to set left buffer

	call rbrytovec(sendvec,recvec,nsize)

c       exchange info - send to right


        call cmsend(blockid+1,1,sendvec,nsize)


c       left shift to set right buffer - not required

c       exchange info - receive from right

       
        call cmrec(blockid+1,1,recvec,nsize)

c       store information received

	call vectorig(sendvec,recvec,nsize)

c       down shift to set up buffer

        
        call bbrytovec(sendvec,recvec,nsize)

c       exchange info - send to bottom

        call cmsend(blockid+nsy,1,sendvec,nsize)

c       up shift to set down buffer
c       exchange info - receive from botton


	call cmrec(blockid+nsy,1,recvec,nsize)

c       store information received


	call vectobot(sendvec,recvec,nsize)

       return
       end

*************************************************************************
*************************************************************************

      subroutine bufdat1(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c       right shift to set left buffer

        call rbrytovec(sendvec,recvec,nsize)

c     exchange info - receive from left send to right

        call cmsenrec(blockid-1,1,recvec,nsize,
     1			      blockid+1,1,sendvec,nsize)
			
c       store information received

        call vectolef(sendvec,recvec,nsize)


c       left shift to set right buffer

        call lbrytovec(sendvec,recvec,nsize)

c        exchange info - receive from right send to left

        call cmsenrec(blockid+1,1,recvec,nsize,
     1			      blockid-1,1,sendvec,nsize)

c       store information received

        call vectorig(sendvec,recvec,nsize)

c       down shift to set up buffer ( not required)

        call bbrytovec(sendvec,recvec,nsize)

c         exchange info - send to bottom

	 call cmsend(blockid+nsy,1,sendvec,nsize)

c         up shift to set down buffer

c         exchange info - receive from botton
	 call cmrec(blockid+nsy,1,recvec,nsize)
	
c          store information received

        call vectobot(sendvec,recvec,nsize)

            return
              end

************************************************************************
************************************************************************

      subroutine bufdat2(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
c	/* exchange info - receive from left */

	call cmrec(blockid-1,1,recvec,nsize)
c	/* store information received */
	        call vectolef(sendvec,recvec,nsize)

c	/* left shift to set right buffer */
                call lbrytovec(sendvec,recvec,nsize)

c	/* exchange info - send to left */
	call cmsend(blockid-1,1,sendvec,nsize)

c	/* down shift to set up buffer */
        call bbrytovec(sendvec,recvec,nsize)

c	/* exchange info - send to bottom */
	call cmsend(blockid+nsy,1,sendvec,nsize)

c	/* up shift to set down buffer */
c	/* exchange info - receive from botton */
	call cmrec(blockid+nsy,1,recvec,nsize)
c	/* store information received */
        call vectobot(sendvec,recvec,nsize)

       return
       end

************************************************************************
************************************************************************
      subroutine bufdat3(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
        call rbrytovec(sendvec,recvec,nsize)

c	/* exchange info with node on right*/
	call cmsend(blockid+1,1,sendvec,nsize)

c	/* left shift to set right buffer */
c	/* exchange info - receive from right */
	call cmrec(blockid+1,1,recvec,nsize)

c	/* store information received */
        call vectorig(sendvec,recvec,nsize)

c	/* down shift to set up buffer */
        call bbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from up send to botton */
	call cmsenrec(blockid-nsy,1,recvec,nsize,
     1			      blockid+nsy,1,sendvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from down send to up */
	call cmsenrec(blockid+nsy,1,recvec,nsize,
     1			      blockid-nsy,1,sendvec,nsize)
c	/* store information received */
        call vectobot(sendvec,recvec,nsize)

       return
       end

************************************************************************
************************************************************************
      subroutine bufdat4(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
        call rbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from left send to right */
	call cmsenrec(blockid-1,1,recvec,nsize,
     1			      blockid+1,1,sendvec,nsize)
c	/* store information received */
                call vectolef(sendvec,recvec,nsize)

c	/* left shift to set right buffer */
        call lbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from right send to left */
	call cmsenrec(blockid+1,1,recvec,nsize,
     1			      blockid-1,1,sendvec,nsize)
c	/* store information received */
        call vectorig(sendvec,recvec,nsize)

c	/* down shift to set up buffer */
        call bbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from up send to botton */
	call cmsenrec(blockid-nsy,1,recvec,nsize,
     1			      blockid+nsy,1,sendvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from down send to up */
	call cmsenrec(blockid+nsy,1,recvec,nsize,
     1			      blockid-nsy,1,sendvec,nsize)
c	/* store information received */
        call vectobot(sendvec,recvec,nsize)

       return
       end

************************************************************************
************************************************************************
      subroutine bufdat5(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
c	/* exchange info - receive from left */
	call cmrec(blockid-1,1,recvec,nsize)
c	/* store information received */
                call vectolef(sendvec,recvec,nsize)

c	/* left shift to set right buffer */
        call lbrytovec(sendvec,recvec,nsize)

c	/* exchange info - send to left */
	call cmsend(blockid-1,1,sendvec,nsize)

c	/* down shift to set up buffer */
        call bbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from up send to botton */
	call cmsenrec(blockid-nsy,1,recvec,nsize,
     1			      blockid+nsy,1,sendvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from down send to up */
	call cmsenrec(blockid+nsy,1,recvec,nsize,
     1			      blockid-nsy,1,sendvec,nsize)
c	/* store information received */
        call vectobot(sendvec,recvec,nsize)

       return
       end

************************************************************************
************************************************************************
      subroutine bufdat6(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
        call rbrytovec(sendvec,recvec,nsize)

c	/* exchange info with node on right*/


	call cmsend(blockid+1,1,sendvec,nsize)

c	/* left shift to set right buffer */
c	/* exchange info - receive from right */
	call cmrec(blockid+1,1,recvec,nsize)
c	/* store information received */
        call vectorig(sendvec,recvec,nsize)

c	/* down shift to set up buffer */
c	/* exchange info - receive from up */
	call cmrec(blockid-nsy,1,recvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info with node on top*/
	call cmsend(blockid-nsy,1,sendvec,nsize)
       return
       end

************************************************************************
************************************************************************
      subroutine bufdat7(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
        call rbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from left send to right */
	call cmsenrec(blockid-1,1,recvec,nsize,
     1			      blockid+1,1,sendvec,nsize)
c	/* store information received */
                call vectolef(sendvec,recvec,nsize)

c	/* left shift to set right buffer */
        call lbrytovec(sendvec,recvec,nsize)

c	/* exchange info - receive from right send to left */
	call cmsenrec(blockid+1,1,recvec,nsize,
     1			      blockid-1,1,sendvec,nsize)
c	/* store information received */
        call vectorig(sendvec,recvec,nsize)

c	/* down shift to set up buffer */
c	/* exchange info - receive from up */
	call cmrec(blockid-nsy,1,recvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info with node on top*/
	call cmsend(blockid-nsy,1,sendvec,nsize)
       return
       end

************************************************************************
************************************************************************
      subroutine bufdat8(sendvec,recvec,nsize)
      include 'commons.aniso'

      complex*16 sendvec(1:nsize),recvec(1:nsize)

c	/* right shift to set left buffer */
c	/* exchange info - receive from left */

	call cmrec(blockid-1,1,recvec,nsize)
c	/* store information received */
                call vectolef(sendvec,recvec,nsize)

c	/* left shift to set right buffer */
        call lbrytovec(sendvec,recvec,nsize)

c	/* exchange info - send to left */
	call cmsend(blockid-1,1,sendvec,nsize)

c	/* down shift to set up buffer */
c	/* exchange info - receive from up */
	call cmrec(blockid-nsy,1,recvec,nsize)
c	/* store information received */
        call vectotop(sendvec,recvec,nsize)

c	/* up shift to set down buffer */
        call tbrytovec(sendvec,recvec,nsize)

c	/* exchange info with node on top*/
	call cmsend(blockid-nsy,1,sendvec,nsize)
        return
        end
*********************************************************************
       subroutine cmsend(b_id,dumb,sendd,size)
       include 'mpif.h'
       include 'commons.aniso'        
       parameter (nsize=6*mnx*(myz+2))
       integer b_id,dumb
       complex*16 sendd(1:nsize),recc(1:nsize)
       integer size

csp2-----------------------------------------------------------------------
        itag=1
	call MPI_SEND(sendd,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (11)'
           stop
         endif
csp2  -----------------------------------------------------------

       return
       end       
********************************************************************
       subroutine cmrec(b_id,dumb,recc,size)
       include 'mpif.h'
       include 'commons.aniso'        
       integer status(MPI_STATUS_SIZE)       
csp2  ---------------------------------------------    
       parameter (nsize=6*mnx*(myz+2))
       integer b_id,dumb
       complex*16 sendd(1:nsize),recc(1:nsize)
       integer size
csp2-----------------------------------------------------------------------

        itag=1
        call MPI_RECV(recc,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,status,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (12)'
           stop
         endif
csp2  ------------------------------------------------------

       return
       end
*********************************************************************
       subroutine cmsenrec(b_id1,dumb1,recc,size1,
     1                     b_id2,dumb2,sendd,size2)
       include 'mpif.h'
       include 'commons.aniso'        
       integer status(MPI_STATUS_SIZE)     
csp2  ---------------------------------------------------- 
       parameter (nsize=6*mnx*(myz+2))
       integer b_id1,dumb1,b_id2,dumb2
       complex*16 sendd(1:nsize),recc(1:nsize)
       integer size1,size2
csp2-----------------------------------------------------------------------
        itag=1
        call MPI_SEND(sendd,size2,MPI_DOUBLE_COMPLEX,b_id2,
     1                itag,MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (13)'
           stop
         endif
csp2 ----------------------------------------------------------------
csp2-----------------------------------------------------------------------
        itag=1
        call MPI_RECV(recc,size1,MPI_DOUBLE_COMPLEX,b_id1,
     1                itag,MPI_COMM_WORLD,status,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (14)'
           stop
         endif
csp2  ------------------------------------------------------------------

       return
       end
***********************************************************       
**************************************************************************
       subroutine cmsendxy(b_id,dumb,sendd,size)
csp2--------------------------------------------------------------------
        include 'mpif.h' 
        include 'commons.aniso'
csp2----------------------------------------------------             
csp2 ---------------------------------------------------------------------  
       parameter (nsize=6*mnx*(myz+2))
       integer b_id,dumb,size
       complex*16 sendd(1:nsize)

c      TMP - PARALLEL CODE
c       call csend(blockid,sendd,size,b_id,0)
csp2 -------------------------------------------------------
	itag=1
        call MPI_SEND(sendd,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (7)'
           stop
         endif
csp2 ------------------------------------------------------------
       return
       end
*********************************************************************
       subroutine cmrecxy(b_id,dumb,recc,size)
       include 'commons.aniso'
csp2----------------------------------------------------------------------
	include 'mpif.h'
csp2---------------------------------------------------------
	
	integer status(MPI_STATUS_SIZE)       
csp2 ---------------------------------------------------------   
       parameter (nsize=6*mnx*(myz+2))    
       integer b_id,dumb,size

       complex*16 recc(1:nsize)

c      TMP - PARALLEL CODE
c       call crecv(b_id,recc,size)
csp2-----------------------------------------------------------------------
        itag=1
        call MPI_RECV(recc,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,status,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (8)'
           stop
         endif
csp2 -----------------------------------------------------------

       return
       end
**************************************************************************
cFix   2 subroutine below when adding  space--time snapshots
c       subroutine cmsendt(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
csp2---------------------------------------------------------
c	include 'sizes'        
c        
csp2 -----------------------------------------------------------  
c       integer b_id,dumb
c       parameter(mnmax=256)
c       real*8 tsendd(0:(mnmax+2)*(mnmax+2)),
c     1        trecc(0:(mnmax+2)*(mnmax+2))
c       integer size
c       integer blockid,vblockid,blockty
c       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
c      TMP - PARALLEL CODE
c       call csend(blockid,tsendd,size,b_id,0)
csp2 ---------------------------------------------------
c        itag=1
c        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif
csp2 ---------------------------------------------------------
c
c       return
c       end
*********************************************************************
c       subroutine cmrect(b_id,dumb,trecc,size)
csp2--------------------------------------------------------------------
c        include 'mpif.h'
csp2---------------------------------------------------------
c	include 'sizes'        
c        integer status(MPI_STATUS_SIZE) 
csp2 -----------------------------------------------------------           
c       integer b_id,dumb
c       parameter(mnmax=256)
c       real*8 tsendd(0:(mnmax+2)*(mnmax+2)),
c     1        trecc(0:(mnmax+2)*(mnmax+2))
c       integer size
c       integer blockid,vblockid,blockty
c
c       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
c
c      TMP - PARALLEL CODE
c       call crecv(b_id,trecc,size)
csp2 ---------------------------------------------------
c        itag=1
c
c     
c         call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
c     1                itag,MPI_COMM_WORLD,status,mpierr)
c         if(mpierr .ne. 0)then
c           write(6,*)' MPI error !!! (9)'
c           stop
c         endif
csp2 ---------------------------------------------------------
c
c       return
c       end
