#!/bin/bash
#SBATCH -N1     
#SBATCH -n16
#SBATCH -t 4:00:00
#SBATCH -A mathdept # The queue you asked to submit to is mathdept
# Deleted the --mem=0 line as this option is deprecated on our clusters.
#mpif90 -c  -g setbuf.f
#mpif90 -c  -g 3DVTI_eje_Z.f
#mpif90 -g -o 3dVTI 3daniso_VTI.o setbuf.o

echo "starting run: `date`" 1>&2
echo $(hostname)
. /etc/profile
module --force purge
module load intel
module load impi
module list

#mpiexec -n 16 ./3dVTI
srun --mpi=pmi2 ./3dVTI
echo "run complete: `date`" 1>&2
